/*
    PPDocumentScaleSheetController.h

    Copyright 2013-2016 Josh Freeman
    http://www.twilightedge.com

    This file is part of PikoPixel for Mac OS X and GNUstep.
    PikoPixel is a graphical application for drawing & editing pixel-art images.

    PikoPixel is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License version 3,
    as published by the Free Software Foundation.

    PikoPixel is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#import "PPDocumentSheetController.h"


@interface PPDocumentScaleSheetController : PPDocumentSheetController
{
    IBOutlet NSImageView *_previewImageView;
    IBOutlet NSTextField *_newSizeTextField;
    IBOutlet NSPopUpButton *_scalingFactorTypePopUpButton;
    IBOutlet NSTextField *_scalingFactorTextField;
    IBOutlet NSSlider *_scalingFactorSlider;

    NSBitmapImageRep *_canvasBitmap;
    NSImage *_canvasImage;
    NSSize _originalSize;
    NSSize _scaledSize;
    unsigned _scalingFactor;
    unsigned _maxScaleUpFactor;
    unsigned _maxScaleDownFactor;

    NSRect _previewScrollViewInitialFrame;
    float _previewScrollerWidth;
    NSPoint _previewViewNormalizedCenter;

    bool _isDownscaling;
    bool _shouldPreservePreviewNormalizedCenter;
}

+ (bool) beginScaleSheetForDocumentWindow: (NSWindow *) window
            canvasBitmap: (NSBitmapImageRep *) canvasBitmap
            delegate: (id) delegate;

- (IBAction) scalingFactorTypePopUpButtonItemSelected: (id) sender;
- (IBAction) scalingFactorSliderMoved: (id) sender;

@end

@interface NSObject (PPDocumentScaleSheetDelegateMethods)

- (void) documentScaleSheetDidFinishWithNewImageSize: (NSSize) newImageSize;

- (void) documentScaleSheetDidCancel;

@end
